function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

/**
 * @copyright 2020 Tridium, Inc. All Rights Reserved.
 * @author James Johnson
 */

/**
 * API Status: **Private**
 * @module nmodule/vykonPro/rc/binding/ViewNameBinding
 */
define(['baja!', 'Promise', 'nmodule/bajaui/rc/baja/binding/Binding', 'nmodule/webEditors/rc/wb/profile/profileUtils', 'css!nmodule/bajaui/rc/bajaui'], function (baja, Promise, Binding, profileUtils) {
  'use strict';
  /**
   * @class
   * @alias module:nmodule/vykonPro/rc/binding/ViewNameBinding
   * @extends module:nmodule/bajaui/rc/baja/binding/Binding
   */

  return /*#__PURE__*/function (_Binding) {
    _inherits(ViewNameBinding, _Binding);

    var _super = _createSuper(ViewNameBinding);

    function ViewNameBinding() {
      _classCallCheck(this, ViewNameBinding);

      return _super.apply(this, arguments);
    }

    _createClass(ViewNameBinding, [{
      key: "provide",
      value:
      /**
       * Converts the bound `BObject` to a type that is compatible with the target
       * property on the bound `Widget`.
       *
       * @param {string} name
       * @returns {Promise.<*|null>}
       */
      function provide(name) {
        if (!this.isBound() || !name.equals("text")) {
          return null;
        }

        var tformat = this.get("textFormat").toString();
        var ordTarget = this.getOrdTarget();
        return profileUtils.resolveCurrentViewId().then(function (item) {
          if (item) {
            return profileUtils.getOrdWithoutViewQuery().relativizeToSession().get().then(function (rootComp) {
              var viewDn = rootComp.getDisplayName(rootComp.getSlot(item));
              tformat = tformat.replace("viewName", viewDn);
              var fmt = baja.Format.make(tformat);
              return resolveText(ordTarget, fmt).then(function (textValue) {
                return textValue;
              });
            });
          }
        });
      }
    }]);

    return ViewNameBinding;
  }(Binding);
  /**
   * @returns {Promise}
   */

  function resolveText(ordTarget, fmt) {
    return fmt.format({
      object: ordTarget.getObject()
    });
  }
});
